#!/usr/bin/perl 

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# CGI Header and Footer
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$fw_header = <<_END_;
  <html>
    <head>
      <title>FWCONFIG</title>
    </head>
    <body text="white" bgcolor="black" link="#AAAAAA" 
		vlink="#AAAAAA" alink="#AAAAAA">
_END_

$fw_footer = <<_END_;
  </body>
  </html>
_END_

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Standard button
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$button = <<_END_;
  <form><INPUT TYPE="button" VALUE="Home" 
	onClick="location='fwconfig.pl'">
  </form>
_END_

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub print_error {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  my $err_message = $_[0];
  
  print "$fw_header";
  print "<center>\n";
  print "$err_message<br><br>";
  print "<form><input type=\"button\" value=\"Back\" " .
	"onClick=\"history.go(-1)\"></form>";
  print "</center></body></html>\n";
  exit (0);
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub LoadHTML {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  my $html_file = $_[0];
  
  open(FD, "$html_file") 
	|| &print_error("Couldn't open $html_file: $!\n");
  while (<FD>) {
    print;
  }
  close(FD);
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub PrintHiddenVars {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  while ( ($key, $value) = each %pairs ) {
    # skip over variables whose names start with underscore ('_')
    next if ($key =~ /^_/);

    print "<input type=\"hidden\" name=\"$key\" ".
          "value=\"" . &RemoveGarbage($value) . "\">\n";
  }
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub RemoveGarbage {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  $myurl = $_[0];
  $myurl =~ s/"//g;
  $myurl =~ s/[><]//g;
  $myurl =~ s/(^\s+|\s+$)//g;
  return "$myurl";
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub PrintContentType {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  print "Content-type: text/html\n\n";
}

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
sub main {
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  my $CGI_buffer = "";
  my @pairs, @parts = ();
  my $name, $value = "";

  if ($ENV{'REQUEST_METHOD'} eq "POST") {
    read(STDIN, $CGI_buffer, $ENV{'CONTENT_LENGTH'});
  }
  else {
    $CGI_buffer = $ENV{'QUERY_STRING'};
  }

  @pairs = split('&', $CGI_buffer);

  foreach (@pairs) {
    ($name, $value) = split('=', $_);
    
    # replace '+' with space and decode hexified chars
    $name  =~ tr/+/ /;
    $value =~ tr/+/ /;
    $name  =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/gie;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/gie;

    # Skip generally blank fields
    next if ($value eq "");
  
    if ($pairs{$name} ne "") {
      $pairs{$name} .= "~$value";
    } else {
      $pairs{$name} = "$value";
    }
  }
}

1; # Needed to return true value for require()
